#!/bin/sh

# !!!! WARNING !!! BeagleBone header's pins are connected directly to microcontroler's pins,
# e.g. it use 3.3V logic and sink/source few miliampers only. Connecting external voltage higer then 3.3V 
# probably demage your BeagleBone MCU and/or other chips. 
# Practical recomendation is use protective circuit for all input and some driver for output
# (at least transistor for digital output). Only SPI and I2C could be connected directly to 
# devices on your expansion board if they use 3.3V logic (not 5V logic). LED (light emiting diode)
# could be connected directly to BeagleBone pin (with current limiting resistor).
# The UART is incopatibile with RS-232 and RS-485 standards and require external driver. 
# The CAN bus also require driver.

#BBDRV allow access for many peripheral deviceis of the BeagleBone (its MCU AM335x respectively).
#This devices must be all enabled using DeviceTreeSubsystem.
#Depending on board revision, processor revision, linux kernel version, debian version 
#command are different and couldn't be hardcoded in BBDrv_t.so directly.
#there are many examples on internet how to do it correctly;
#you need some variants of commands bellow.

#I found all necessary *.dts files on my BeagleBoneBlack in /opt/source directory. Use folowing command to find them
# find /opt/source | grep dts

#*.dts file must be compiled into binary file. Example of the command is
#dtc -O dtb -o BB-SPI0-01-00A0.dtbo -b 0 -@ BB-SPI0-01-00A0.dts

#Generated *.dtso file must be copied into /lib/firmware directory.
#I already have all necesary *.dtbo files in correct directory, but when you need change anything, you must copy it
#cp BB-SPI0-01-00A0.dtbo /lib/firmware/

#Previous command are expected too do manually while system is installed, 
#but followed command should be in this file and run before RexCore start.
#Be carefull which device can run simultaneoustly! Some device share io pins and couldn't be used at once.
#Not all pins of the AM335x are available on BeagleBone's pin headers, so some devices are not accessible at all.
#Nice table with this conflict could be found  in http://robotic-controls.com/node/68 
#Some device conflict with HDMI or internal storage. If you not use it, you can 'switch it off adding following lines into file /boot/uEnv.txt
#(this commands already was on my BeagleBone - it is enought to uncoment them)
#cape_disable=capemgr.disable_partno=BB-BONELT-HDMI,BB-BONELT-HDMIN
#cape_disable=capemgr.disable_partno=BB-BONE-EMMC-2G

#Now you must aplly *.dtbo files. This action parametrize and start kernel drive for required device
#You should check system log (dmesg command) to be sure everything is ok.

#----------------------------------------------------------------------------------
#To enable GPIO 2_5 (digital input or output) uncomment following line (or add simmilar line for other GPIO )
#echo PyBBIO-gpio2_5 > /sys/devices/bone_capemgr.9/slots
#??? stejny efekt by melo mit pridat do /boot/uEnv.txt  prikaz capemgr.enable_partno=PyBBIO-gpio2_5
#ale projevi se to az po rebootu a nezkousel jsem to (analogicky samozrejme ostatni *.dtbo)

#To check manually if everything work, you can use commands
#echo 69 > /sys/classes/gpio/export
#echo out > /sys/classes/gpio/gpio69/direction
#echo 1 > /sys/classes/gpio/gpio69/value

#----------------------------------------------------------------------------------
#To enable AIN1 (analog input) uncomment following lines (or add simmilar line for other analog input )
#echo PyBBIO-ADC > /sys/devices/bone_capemgr.9/slots
#echo PyBBIO-AIN1 > /sys/devices/bone_capemgr.9/slots

#To check manually if everything work, you can use command (asterisk should be replaced by correct nuber - browse your filesytem)
#cat /sys/devices/ocp.*/PyBBIO-AIN1.*/AIN1

#----------------------------------------------------------------------------------
#The AM335x contains 3 PWMSS units. Each unit contains one PWM, one CAP and one QEP. Each PWM unit has two complementary outputs.
#To enable PWM1 (pulse-wide-modulator) uncomment following lines (or add simmilar line for other pwm )
#echo PyBBIO-epwmss1 > /sys/devices/bone_capemgr.9/slots
#echo PyBBIO-ehrpwm1 > /sys/devices/bone_capemgr.9/slots

#To check manually if everything work, you can use command (asterisk should be replaced by correct nuber - browse your filesytem)
#echo 1 > /sys/classes/pwm/export
#echo 0 > /sys/classes/pwm/pwm1/polarity
#echo 1000000 > /sys/classes/pwm/pwm1/period_ns
#echo 1 > /sys/classes/pwm/pwm1/run
#echo 300000 > /sys/classes/pwm/pwm1/duty_ns

#----------------------------------------------------------------------------------
#To enable QEP1 (quadrature-encode-pulse, also known as IRC) uncomment following lines (or add simmilar line for other qep )
#modprobe tieqep
#echo PyBBIO-epwmss1 > /sys/devices/bone_capemgr.9/slots
#echo PyBBIO-eqep1 > /sys/devices/bone_capemgr.9/slots
#!!!! zkusit jeste PyBBIO-ehrqep1 a PyBBIO-ecap1 (a doplnit QEP, CAP), ale zatim nevim, jak se k tomu dostat 

#To check manually if everything work, you can use command (asterisk should be replaced by correct nuber - browse your filesytem)
#echo 0 > /sys/devices/ocp.*/*.epwmss/*.eqep/mode
#echo 10000 > /sys/devices/ocp.*/*.epwmss/*.eqep/period
#echo 1 > /sys/devices/ocp.*/*.epwmss/*.eqep/enabled
#cat /sys/devices/ocp.*/*.epwmss/*.eqep/position

#----------------------------------------------------------------------------------
#????doplnit CAP
#echo PyBBIO-epwmss1 > /sys/devices/bone_capemgr.9/slots
#echo PyBBIO-ecap1 > /sys/devices/bone_capemgr.9/slots



#----------------------------------------------------------------------------------
#The AM335x contains 6 UART. By default UART0 is enabled, but not connected on BeagleBone's pin header (it is connected on debug connector J1 pin4=RX, pin5=TX)
#UART3 hasn't available RX pin (only TX is available) and not exist *.dtbo file for them by default.
#To enable UART1 uncomment following line (or add simmilar line for other uart )
#echo ADAFRUIT-UART1 > /sys/devices/bone_capemgr.9/slots

#To check manually if everything work, you should see file /dev/ttyO1 which act as common serial line. You can try command like
#ls /dev/ttyO*
#stty -F /dev/ttyO1
#echo HelloWorld >/dev/ttyO1
#cat /dev/ttyO1

#----------------------------------------------------------------------------------
# I2C is enabled by default. You should see /dev/i2c-0 and /dev/i2c-1 files. i2c-2 could be enabled known way, but you must create/find *.dts/*dtbo file
# For tests, You can try commands like 
#i2cdetect -l
#i2cdetect -r 0 
#i2cdump -y 2 0x77

#----------------------------------------------------------------------------------
#To enable SPI0 uncomment following line (or add simmilar line for other spi )
#echo ADAFRUIT-SPI0 > /sys/devices/bone_capemgr.9/slots

#To check manualy if everything work, you should see file /dev/spidev1.0 .
#Sometimes you can see also /dev/spidev1.1 which is same SPI line but use different chipselect pin for second slave.
#Anyway you can connect chipselect of your slave to any GPIO and control it manualy.

#----------------------------------------------------------------------------------
#To enable DCAN1 uncomment following lines (or add simmilar line for other spi )
#modprobe can
#modprobe can-dev
#modprobe can-raw
#echo BB-DCAN1 > /sys/devices/bone_capemgr.9/slots


#To check manualy if everything work, you should see can0 within network devices. Use command
#ip link
#Notice1: this driver assign first added device can0, second added device can1 and so on.
#Notice2: modprobe commands are usually not necessary, but you must configure can0 interface - see 80-candrvt.sh
#You must check network device option in candrvt configuration if you want use the device in rex-candrvt

#----------------------------------------------------------------------------------
#It take few seconds to initialize all drivers and devices and initialization is asynchronous. It could be necessary to wait
#sleep 10

exit 0
